<?xml version="1.0" encoding="windows-1252" ?>
<!--
		This transformation is applied to non-standard XPDL 2.1 documents in
		order to convert them into standard form as it is specified in XML
		schema for XPDL v2.1.
                
                Date        Who         Change
                =========   =========== ====================================================
                11-Jan-10   N.Kumar     .created.
                                        .'redrawConnections'ExtendedAttribute included
                                        .create pages element in xml. seems not working while applying transformations in java.
                                        
                29-Jan-10   N.Kumar     .'handleFlowsAgain' ExtendedAttribute included
                                        .template to add source coord. to flow coord. commented out 
                                        .template to create 'redrawConnections' ExtendedAttribute is also commented out.
             
                09-Jun-10   N.Kumar     .template to create unique page elements included.
-->
<xsl:stylesheet version="2.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xpdl21="http://www.wfmc.org/2008/XPDL2.1">
  
  <xsl:output method="xml" indent="yes" />
  
  <!-- Root template -->
  <xsl:template match="@*|node()">
    <xsl:copy>
        <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>
  
  <!--add source coordinates to coordinates of Transition to make them relative to pool-->
  <!--xsl:template match="xpdl21:Transition/xpdl21:ConnectorGraphicsInfos/xpdl21:ConnectorGraphicsInfo/xpdl21:Coordinates">
    <xsl:copy>
        <xsl:copy-of select="@*[name() != 'XCoordinate' and name() != 'YCoordinate']"/>
        <xsl:variable name="sourceId">
            <xsl:value-of select="ancestor::xpdl21:Transition/@From"/>
        </xsl:variable>
        <xsl:attribute name="XCoordinate">
            <xsl:value-of select="//xpdl21:Activity[@Id = $sourceId]/xpdl21:NodeGraphicsInfos/xpdl21:NodeGraphicsInfo/xpdl21:Coordinates/@XCoordinate + 
								  //xpdl21:Activity[@Id = $sourceId]/xpdl21:NodeGraphicsInfos/xpdl21:NodeGraphicsInfo/@Width + 	
                                  @XCoordinate"/>
        </xsl:attribute>
        <xsl:attribute name="YCoordinate">
            <xsl:value-of select="//xpdl21:Activity[@Id = $sourceId]/xpdl21:NodeGraphicsInfos/xpdl21:NodeGraphicsInfo/xpdl21:Coordinates/@YCoordinate +
								  //xpdl21:Activity[@Id = $sourceId]/xpdl21:NodeGraphicsInfos/xpdl21:NodeGraphicsInfo/@Height div 2 + 
                                  @YCoordinate"/>
        </xsl:attribute>
        <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template-->
  
  <!--move activities towards upper left corner by half of width and height-->
  <!--xsl:template match="xpdl21:Activity/xpdl21:NodeGraphicsInfos/xpdl21:NodeGraphicsInfo/xpdl21:Coordinates">
    <xsl:copy>
        <xsl:copy-of select = "@*[name() != 'XCoordinate' and name() != 'YCoordinate']"/>
        <xsl:attribute name = "XCoordinate">
            <xsl:value-of select = " @XCoordinate - ancestor::xpdl21:NodeGraphicsInfo/@Width div 2 "/>
        </xsl:attribute>
        <xsl:attribute name = "YCoordinate">
            <xsl:value-of select=" @YCoordinate - ancestor::xpdl21:NodeGraphicsInfo/@Height div 2 " />
        </xsl:attribute>
        <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template-->
  
  <!-- Add 'handleFlowsAgain' ExtendedAttribute when xpdl already contains ExtendedAttributes element -->
  <xsl:template match="xpdl21:Package/xpdl21:ExtendedAttributes">
    <xsl:copy>
        <xsl:copy-of select="@*"/>
        <xpdl21:ExtendedAttribute Name = "handleFlows" Value = "true"/>
        <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template>
  <!--    
            Adding 'redrawConnections' ExtendedAttribute when xpdl already contains ExtendedAttributes element
     -->
        <!--xsl:template match="xpdl21:Package/xpdl21:ExtendedAttributes">
            <xsl:copy>
                <xsl:copy-of select="@*"/>
                <xpdl21:ExtendedAttribute Name="redrawConnections" Value="true"/>
                <xsl:apply-templates/>                                
            </xsl:copy>
        </xsl:template-->
  
  <!--logic1 to create unique page elements, not working with jdk1.5-->
  <!--xsl:template match="xpdl21:Package">
    <xsl:copy>
        <xsl:copy-of select="@*"/>
        <xsl:element name="Pages">
            <xsl:for-each-group select="//xpdl21:NodeGraphicsInfo" group-by="@Page">
                <xsl:element name="Page">
                    <xsl:attribute name="Id">
                        <xsl:value-of select="@Page"/>
                    </xsl:attribute>
                    <xsl:attribute name="Name">
                        <xsl:value-of select="@Page"/>
                    </xsl:attribute>
                </xsl:element>
            </xsl:for-each-group>
        </xsl:element>
        <include extended Attribute redrawConnections>
        <xsl:if test="not(child::xpdl21:ExtendedAttributes)">
            <xpdl21:ExtendedAttributes>
                <xpdl21:ExtendedAttribute Name="redrawConnections" Value="true"/>
            </xpdl21:ExtendedAttributes>
        </xsl:if>

        <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template-->
  <!--logic2:create unique page elements, working in BPA, but not in jdeveloper-->
  <!--xsl:template match="xpdl21:Package">
    <xsl:copy>
        <xsl:copy-of select="@*"/>
        <xsl:variable name="unique-page-ids" select="//xpdl21:NodeGraphicsInfo/@Page[not(. = following::xpdl21:NodeGraphicsInfo/@Page)]"/>
        <xsl:element name="Pages">
            <xsl:for-each select="$unique-page-ids">
                <xsl:element name="Page">
                    <xsl:attribute name="Id">
                        <xsl:value-of select="."/>
                    </xsl:attribute>
                    <xsl:attribute name="Name">
                        <xsl:value-of select="."/>
                    </xsl:attribute>
                </xsl:element>
            </xsl:for-each>
        </xsl:element-->
            
        <!--set extended attribute to handle flows again-->
        <!--xsl:if test="not(child::xpdl21:ExtendedAttributes)">
            <xpdl21:ExtendedAttributes>
                <xpdl21:ExtendedAttribute Name = "handleFlows" Value = "true"/>
            </xpdl21:ExtendedAttributes>
        </xsl:if-->
        <!--include extended Attribute redrawConnections-->
        <!--xsl:if test="not(child::xpdl21:ExtendedAttributes)">
            <xpdl21:ExtendedAttributes>
                <xpdl21:ExtendedAttribute Name="redrawConnections" Value="true"/>
            </xpdl21:ExtendedAttributes>
        </xsl:if-->

        <!--xsl:apply-templates/>
    </xsl:copy>
  </xsl:template-->
  
  <xsl:template match="xpdl21:Package">
    <xsl:copy>
        <xsl:copy-of select="@*"/>
        <xsl:element name="Pages">
            <xsl:for-each select="//xpdl21:NodeGraphicsInfo/@Page[not(.=preceding::xpdl21:NodeGraphicsInfo/@Page)]">
                <xsl:element name="Page">
                    <xsl:attribute name="Id">
                        <xsl:value-of select="."/>
                    </xsl:attribute>
                    <xsl:attribute name="Name">
                        <xsl:value-of select="."/>
                    </xsl:attribute>
                </xsl:element>
            </xsl:for-each>
        </xsl:element>

        
        <!--include extended Attribute redrawConnections-->
        <xsl:if test="not(child::xpdl21:ExtendedAttributes)">
            <xpdl21:ExtendedAttributes>
                <xpdl21:ExtendedAttribute Name="handleFlows" Value="true"/>
            </xpdl21:ExtendedAttributes>
        </xsl:if>

        <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template> 
  
  <!--logic3:create unique page elements, working in BPA, but not in jdeveloper-->  
  <!--xsl:template match="xpdl21:Package">
    <xsl:copy>
        <xsl:copy-of select="@*"/>
        <xsl:key match="xpdl21:NodeGraphicsInfo" name="distinctPageName" use="@Page"/-->
        <!--xsl:variable name="unique-page-ids" select="//xpdl21:NodeGraphicsInfo/@Page[not(. = following::xpdl21:NodeGraphicsInfo/@Page)]"/-->
        <!--xsl:element name="Pages">
            <xsl:for-each select="//xpdl21:NodeGraphicsInfo[generate-id() = generate-id(key('distinctPageName',@Page)[1])]">
                <xsl:element name="Page">
                    <xsl:attribute name="Id">
                        <xsl:value-of select="@Page"/>
                    </xsl:attribute>
                    <xsl:attribute name="Name">
                        <xsl:value-of select="@Page"/>
                    </xsl:attribute>
                </xsl:element>
            </xsl:for-each>
        </xsl:element-->

        
        <!--include extended Attribute redrawConnections-->
        <!--xsl:if test="not(child::xpdl21:ExtendedAttributes)">
            <xpdl21:ExtendedAttributes>
                <xpdl21:ExtendedAttribute Name="redrawConnections" Value="true"/>
            </xpdl21:ExtendedAttributes>
        </xsl:if>

        <xsl:apply-templates/>
    </xsl:copy>
  </xsl:template-->  
</xsl:stylesheet>
