<?xml version="1.0"?>

<!--  $Header: soatutor/integration/visio/xml/VisioReducer.xsl /st_pcbpel_11.1.1.4.0/1 2011/09/09 12:33:22 fevers Exp $ -->

<!-- 
 Copyright (c) 2011, Oracle and/or its affiliates. All rights reserved. 

   NAME
     VisioMasterMap.xml - <one-line expansion of the name>

   DESCRIPTION
     <short description of component this file declares/defines>

   NOTES
     <other useful comments, qualifications, etc.>

   MODIFIED   (MM/DD/YY)
   fevers      03/23/11 - adding tutor xml-related files
   fevers      03/23/11 - Creation

-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:vdx="http://schemas.microsoft.com/visio/2003/core">
	<xsl:output method="xml" indent="yes"/>
	<!-- Root template -->
	<xsl:template match="@*|node()">
		<xsl:copy>
			<xsl:apply-templates select="@*|node()"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="vdx:DocumentProperties">
		<xsl:copy>
			<xsl:copy-of select="@*"/>
			<xsl:copy-of select="node()[local-name() = 'Title' or local-name()='Creator' or local-name()='TimeCreated' or local-name()='TimeEdited' or local-name()='Template']"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="vdx:Colors|vdx:FaceNames|vdx:DocumentSettings|vdx:StyleSheets|vdx:DocumentSheet|vdx:VBProjectData|vdx:HeaderFooter|vdx:Windows"/>
	<xsl:template match="vdx:Masters">
		<xsl:copy>
			<xsl:apply-templates/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="vdx:Master">
		<xsl:copy>
			<xsl:copy-of select="@ID | @NameU | @Name"/>
			<xsl:apply-templates select="node()[local-name() != 'Icon' and local-name() != 'PageSheet' and local-name() != 'Shapes']"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="vdx:Pages">
		<xsl:copy>
			<xsl:apply-templates/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="vdx:Page">
		<xsl:copy>
			<xsl:copy-of select="@*"/>
			<xsl:apply-templates select="node()[local-name() !='PageSheet']"/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="vdx:Shapes">
		<xsl:copy>
			<xsl:apply-templates/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="vdx:Shape">
		<xsl:copy>
			<xsl:copy-of select="@*"/>
			<xsl:apply-templates/>
		</xsl:copy>
	</xsl:template>
	<xsl:template match="vdx:Masters/Master/PageSheet"/>
	<xsl:template match="vdx:Pages/Page/PageSheet"/>
	<!--<xsl:template match="@*|node()"/>-->
</xsl:stylesheet>
